﻿using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Input;

namespace XDGDragToTreeView
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void StartDraggingXDG(object sender, MouseButtonEventArgs e)
        {
            Dispatcher.BeginInvoke(new Action(() =>
            {
                List<DataRecord> selectedDRs = new List<DataRecord>();
                if (xamDataGrid1.SelectedItems.Records.Count > 0)
                {
                    foreach (Record rec in xamDataGrid1.SelectedItems.Records)
                    {
                        if (rec is DataRecord)
                        {
                            selectedDRs.Add((rec as DataRecord));
                        }
                    }

                }
                DragDrop.DoDragDrop(sender as DependencyObject, selectedDRs, DragDropEffects.Copy);
            }), System.Windows.Threading.DispatcherPriority.Render, null);
        }

        private void TreeView_Drop(object sender, DragEventArgs e)
        {
            string text = "";

            List<DataRecord> drs = e.Data.GetData(e.Data.GetFormats()[0]) as List<DataRecord>;

            if (drs != null)
            {
                foreach (DataRecord dr in drs)
                {
                    text = "";
                    foreach (Cell cell in dr.Cells)
                    {
                        text += cell.Value + ", ";
                    }
                    this.treeView.Items.Add(text.Substring(0, text.Length - 2));
                }
            }
        }
    }
}
